clear all;
close all;

%axis
per = 100;
Foreign(1,1)=0;
for i = 2:per;
Foreign(i,1) =Foreign(i-1,1) +0.01;
end

%DSGE
dp1(1,1)=0.5;
for i = 2:per;
dp1(i,1) =dp1(i-1,1) +0.01;
end

c1=0.50;
qsc=Foreign-c1; 
g=zeros(length(qsc),1);

gam1_a10=10;
gam2_a10=10;
gam1_b10=10;
gam2_b10=-10;
gam1_c10=-10;
gam2_c10=10;
gam1_d10=-10;
gam2_d10=-10;

gam1_a5=5;
gam2_a5=5;
gam1_b5=5;
gam2_b5=-5;
gam1_c5=-5;
gam2_c5=5;
gam1_d5=-5;
gam2_d5=-5;

gam1_a1=1;
gam2_a1=1;
gam1_b1=1;
gam2_b1=-1;
gam1_c1=-1;
gam2_c1=1;
gam1_d1=-1;
gam2_d1=-1;

gam1_a0=0;
gam2_a0=0;
gam1_b0=0;
gam2_b0=0;
gam1_c0=0;
gam2_c0=0;
gam1_d0=0;
gam2_d0=0;




if gam1_a10<0;
h1_a10=1./gam1_a10.*log(1-gam1_a10.*abs(qsc));
g1_a10=1./(1+exp(-(h1_a10))) ; 
else
h1_a10=-1./gam1_a10.*(exp(gam1_a10.*abs(qsc))-1);
g1_a10=1./(exp(-(h1_a10))+1); 
end
a1_a10=g1_a10(1:sum(qsc<0),:);
if gam2_a10<0;
h2_a10=-1./gam2_a10.*log(1-gam2_a10.*abs(qsc));
g2_a10=1./(1+exp(-(h2_a10))); 
else 
h2_a10=1./gam2_a10.*(exp(gam2_a10.*abs(qsc))-1);
g2_a10=1./(exp(-(h2_a10))+1);
end 
b2_a10=g2_a10(sum(qsc<0)+1:end,:);
g_a10= vertcat(a1_a10,b2_a10);

%rra5
if gam1_a5<0;
h1_a5=1./gam1_a5.*log(1-gam1_a5.*abs(qsc));
 g1_a5=1./(1+exp(-(h1_a5))) ; 
else
h1_a5=-1./gam1_a5.*(exp(gam1_a5.*abs(qsc))-1);
g1_a5=1./(exp(-(h1_a5))+1); 
end
a1_a5=g1_a5(1:sum(qsc<0),:);
if gam2_a5<0;
h2_a5=-1./gam2_a5.*log(1-gam2_a5.*abs(qsc));
g2_a5=1./(1+exp(-(h2_a5))); 
else 
h2_a5=1./gam2_a5.*(exp(gam2_a5.*abs(qsc))-1);
g2_a5=1./(exp(-(h2_a5))+1);
end 
b2_a5=g2_a5(sum(qsc<0)+1:end,:);
g_a5= vertcat(a1_a5,b2_a5);

%rra1
if gam1_a1<0;
h1_a1=1./gam1_a1.*log(1-gam1_a1.*abs(qsc));
 g1_a1=1./(1+exp(-(h1_a1))) ; 
else
h1_a1=-1./gam1_a1.*(exp(gam1_a1.*abs(qsc))-1);
g1_a1=1./(exp(-(h1_a1))+1); 
end
a1_a1=g1_a1(1:sum(qsc<0),:);
if gam2_a1<0;
h2_a1=-1./gam2_a1.*log(1-gam2_a1.*abs(qsc));
g2_a1=1./(1+exp(-(h2_a1))); 
else 
h2_a1=1./gam2_a1.*(exp(gam2_a1.*abs(qsc))-1);
g2_a1=1./(exp(-(h2_a1))+1);
end 
b2_a1=g2_a1(sum(qsc<0)+1:end,:);
g_a1= vertcat(a1_a1,b2_a1);


%rrb10
if gam1_b10<0;
h1_b10=1./gam1_b10.*log(1-gam1_b10.*abs(qsc));
 g1_b10=1./(1+exp(-(h1_b10))) ; 
else
h1_b10=-1./gam1_b10.*(exp(gam1_b10.*abs(qsc))-1);
g1_b10=1./(exp(-(h1_b10))+1); 
end
a1_b10=g1_b10(1:sum(qsc<0),:);
if gam2_b10<0;
h2_b10=-1./gam2_b10.*log(1-gam2_b10.*abs(qsc));
g2_b10=1./(1+exp(-(h2_b10))); 
else 
h2_b10=1./gam2_b10.*(exp(gam2_b10.*abs(qsc))-1);
g2_b10=1./(exp(-(h2_b10))+1);
end 
b2_b10=g2_b10(sum(qsc<0)+1:end,:);
g_b10= vertcat(a1_b10,b2_b10);

%rrb5
if gam1_b5<0;
h1_b5=1./gam1_b5.*log(1-gam1_b5.*abs(qsc));
 g1_b5=1./(1+exp(-(h1_b5))) ; 
else
h1_b5=-1./gam1_b5.*(exp(gam1_b5.*abs(qsc))-1);
g1_b5=1./(exp(-(h1_a5))+1); 
end
a1_b5=g1_b5(1:sum(qsc<0),:);
if gam2_b5<0;
h2_b5=-1./gam2_b5.*log(1-gam2_b5.*abs(qsc));
g2_b5=1./(1+exp(-(h2_b5))); 
else 
h2_b5=1./gam2_b5.*(exp(gam2_b5.*abs(qsc))-1);
g2_b5=1./(exp(-(h2_b5))+1);
end 
b2_b5=g2_b5(sum(qsc<0)+1:end,:);
g_b5= vertcat(a1_b5,b2_b5);

%rrb1
if gam1_b1<0;
h1_b1=1./gam1_b1.*log(1-gam1_b1.*abs(qsc));
 g1_b1=1./(1+exp(-(h1_b1))) ; 
else
h1_b1=-1./gam1_b1.*(exp(gam1_b1.*abs(qsc))-1);
g1_b1=1./(exp(-(h1_b1))+1); 
end
a1_b1=g1_b1(1:sum(qsc<0),:);
if gam2_b1<0;
h2_b1=-1./gam2_b1.*log(1-gam2_b1.*abs(qsc));
g2_b1=1./(1+exp(-(h2_b1))); 
else 
h2_b1=1./gam2_b1.*(exp(gam2_b1.*abs(qsc))-1);
g2_b1=1./(exp(-(h2_b1))+1);
end 
b2_b1=g2_b1(sum(qsc<0)+1:end,:);
g_b1= vertcat(a1_b1,b2_b1);


%rrc10
if gam1_c10<0;
h1_c10=1./gam1_c10.*log(1-gam1_c10.*abs(qsc));
 g1_c10=1./(1+exp(-(h1_c10))) ; 
else
h1_c10=-1./gam1_c10.*(exp(gam1_c10.*abs(qsc))-1);
g1_c10=1./(exp(-(h1_c10))+1); 
end
a1_c10=g1_c10(1:sum(qsc<0),:);
if gam2_c10<0;
h2_c10=-1./gam2_c10.*log(1-gam2_c10.*abs(qsc));
g2_c10=1./(1+exp(-(h2_c10))); 
else 
h2_c10=1./gam2_c10.*(exp(gam2_c10.*abs(qsc))-1);
g2_c10=1./(exp(-(h2_c10))+1);
end 
b2_c10=g2_c10(sum(qsc<0)+1:end,:);
g_c10= vertcat(a1_c10,b2_c10);


%rrc5
if gam1_c5<0;
h1_c5=1./gam1_c5.*log(1-gam1_c5.*abs(qsc));
 g1_c5=1./(1+exp(-(h1_c5))) ; 
else
h1_c5=-1./gam1_c5.*(exp(gam1_c5.*abs(qsc))-1);
g1_c5=1./(exp(-(h1_c5))+1); 
end
a1_c5=g1_c5(1:sum(qsc<0),:);
if gam2_c5<0;
h2_c5=-1./gam2_c5.*log(1-gam2_c5.*abs(qsc));
g2_c5=1./(1+exp(-(h2_c5))); 
else 
h2_c5=1./gam2_c5.*(exp(gam2_c5.*abs(qsc))-1);
g2_c5=1./(exp(-(h2_c5))+1);
end 
b2_c5=g2_c5(sum(qsc<0)+1:end,:);
g_c5= vertcat(a1_c5,b2_c5);

%rrc1
if gam1_c1<0;
h1_c1=1./gam1_c1.*log(1-gam1_c1.*abs(qsc));
 g1_c1=1./(1+exp(-(h1_c1))) ; 
else
h1_c1=-1./gam1_c1.*(exp(gam1_c1.*abs(qsc))-1);
g1_c1=1./(exp(-(h1_c1))+1); 
end
a1_c1=g1_c1(1:sum(qsc<0),:);
if gam2_c1<0;
h2_c1=-1./gam2_c1.*log(1-gam2_c1.*abs(qsc));
g2_c1=1./(1+exp(-(h2_c1))); 
else 
h2_c1=1./gam2_c1.*(exp(gam2_c1.*abs(qsc))-1);
g2_c1=1./(exp(-(h2_c1))+1);
end 
b2_c1=g2_c1(sum(qsc<0)+1:end,:);
g_c1= vertcat(a1_c1,b2_c1);


%rrd1
if gam1_d10<0;
h1_d10=1./gam1_d10.*log(1-gam1_d10.*abs(qsc));
 g1_d10=1./(1+exp(-(h1_d10))) ; 
else
h1_d10=-1./gam1_d10.*(exp(gam1_d10.*abs(qsc))-1);
g1_d10=1./(exp(-(h1_d10))+1); 
end
a1_d10=g1_d10(1:sum(qsc<0),:);
if gam2_d10<0;
h2_d10=-1./gam2_d10.*log(1-gam2_d10.*abs(qsc));
g2_d10=1./(1+exp(-(h2_d10))); 
else 
h2_d10=1./gam2_d10.*(exp(gam2_d10.*abs(qsc))-1);
g2_d10=1./(exp(-(h2_d10))+1);
end 
b2_d10=g2_d10(sum(qsc<0)+1:end,:);
g_d10= vertcat(a1_d10,b2_d10);

%rrd5
if gam1_d5<0;
h1_d5=1./gam1_d5.*log(1-gam1_d5.*abs(qsc));
 g1_d5=1./(1+exp(-(h1_d5))) ; 
else
h1_d5=-1./gam1_d5.*(exp(gam1_d5.*abs(qsc))-1);
g1_d5=1./(exp(-(h1_d5))+1); 
end
a1_d5=g1_d5(1:sum(qsc<0),:);
if gam2_d5<0;
h2_d5=-1./gam2_d5.*log(1-gam2_d5.*abs(qsc));
g2_d5=1./(1+exp(-(h2_d5))); 
else 
h2_d5=1./gam2_d5.*(exp(gam2_d5.*abs(qsc))-1);
g2_d5=1./(exp(-(h2_d5))+1);
end 
b2_d5=g2_d5(sum(qsc<0)+1:end,:);
g_d5= vertcat(a1_d5,b2_d5);

%rrd1
if gam1_d1<0;
h1_d1=1./gam1_d1.*log(1-gam1_d1.*abs(qsc));
 g1_d1=1./(1+exp(-(h1_d1))) ; 
else
h1_d1=-1./gam1_d1.*(exp(gam1_d1.*abs(qsc))-1);
g1_d1=1./(exp(-(h1_d1))+1); 
end
a1_d1=g1_d1(1:sum(qsc<0),:);
if gam2_d1<0;
h2_d1=-1./gam2_d1.*log(1-gam2_d1.*abs(qsc));
g2_d1=1./(1+exp(-(h2_d1))); 
else 
h2_d1=1./gam2_d1.*(exp(gam2_d1.*abs(qsc))-1);
g2_d1=1./(exp(-(h2_d1))+1);
end 
b2_d1=g2_d1(sum(qsc<0)+1:end,:);
g_d1= vertcat(a1_d1,b2_d1);


if gam1_a0<0;
h1_a0=1./gam1_a0.*log(1-gam1_a0.*abs(qsc));
g1_a0=1./(1+exp(-(h1_a0))) ; 
elseif gam1_a0==0;
h1_a0=qsc;
g1_a0=1./(1+exp(-(h1_a0))) ;    
elseif gam1_a0>0;
h1_a0=-1./gam1_a0.*(exp(gam1_a0.*abs(qsc))-1);
g1_a0=1./(exp(-(h1_a0))+1); 
end
a1_a0=g1_a0(1:sum(qsc<0),:);
if gam2_a0<0;
h2_a0=-1./gam2_a0.*log(1-gam2_a0.*abs(qsc));
g2_a0=1./(1+exp(-(h2_a0))); 
elseif gam1_a0==0;
h2_a0=qsc;
g2_a0=1./(1+exp(-(h2_a0))); 
elseif gam2_a0>0;
h2_a0=1./gam2_a0.*(exp(gam2_a0.*abs(qsc))-1);
g2_a0=1./(exp(-(h2_a0))+1);
end 
b2_a0=g2_a0(sum(qsc<0)+1:end,:);
g_a0= vertcat(a1_a0,b2_a0);


figure1 = figure;
subplot(2,2,1,'Parent',figure1,'FontSize',12);
plot(Foreign,g_a10','b','LineWidth',2); hold on;
plot(Foreign,g_a5','--r','LineWidth',2); hold on;
plot(Foreign,g_a1',':m','LineWidth',2); hold on;
plot(Foreign,g_a0','k','LineWidth',1); hold on;
title('\gamma_{1}\geq 0 and \gamma_{2}\geq 0')
hold on;
plot([c1 c1], [min([0;0]) max([1;1])],':k','LineWidth',2);
xlabel('Threshold variable','fontsize',10);
LEG = legend('\gamma_{1}=10 and \gamma_{2}=10','\gamma_{1}=5 and \gamma_{2}=5','\gamma_{1}=1 and \gamma_{2}=1','\gamma_{1}=0 and \gamma_{2}=0');hold on;
LEG.FontSize = 10;
ylim([0,1]);
hold on;
subplot(2,2,2,'Parent',figure1,'FontSize',12);
plot(Foreign,g_b10','b','LineWidth',2); hold on;
plot(Foreign,g_b5','--r','LineWidth',2); hold on;
plot(Foreign,g_b1',':m','LineWidth',2); hold on;
plot(Foreign,g_a0','k','LineWidth',1); hold on;
title('\gamma_{1}\geq and \gamma_{2}\leq 0')
hold on;
plot([c1 c1], [min([0;0]) max([1;1])],':k','LineWidth',2);
xlabel('Threshold variable','fontsize',10);
LEG = legend('\gamma_{1}=10 and \gamma_{2}=-10','\gamma_{1}=5 and \gamma_{2}=-5','\gamma_{1}=1 and \gamma_{2}=-1','\gamma_{1}=0 and \gamma_{2}=0');hold on;
LEG.FontSize = 10;
ylim([0,1]);
hold on;
subplot(2,2,3,'Parent',figure1,'FontSize',12);
plot(Foreign,g_c10','b','LineWidth',2); hold on;
plot(Foreign,g_c5','--r','LineWidth',2); hold on;
plot(Foreign,g_c1',':m','LineWidth',2); hold on;
plot(Foreign,g_a0','k','LineWidth',1); hold on;
title('\gamma_{1}\leq 0 and \gamma_{2}\geq 0')


hold on;
plot([c1 c1], [min([0;0]) max([1;1])],':k','LineWidth',2);
xlabel('Threshold variable','fontsize',10);
LEG = legend('\gamma_{1}=-10 and \gamma_{2}=10','\gamma_{1}=-5 and \gamma_{2}=5','\gamma_{1}=-1 and \gamma_{2}=1','\gamma_{1}=0 and \gamma_{2}=0');hold on;
LEG.FontSize = 10;
ylim([0,1]);
hold on;

subplot(2,2,4,'Parent',figure1,'FontSize',12);
plot(Foreign,g_d10','b','LineWidth',2); hold on;
plot(Foreign,g_d5','--r','LineWidth',2); hold on;
plot(Foreign,g_d1',':m','LineWidth',2); hold on;
plot(Foreign,g_a0','k','LineWidth',1); hold on;
title('\gamma_{1}\leq 0 and \gamma_{2}\leq 0')
hold on;
plot([c1 c1],[min([0;0]) max([1;1])],':k','LineWidth',2);
xlabel('Threshold variable','fontsize',10);
LEG = legend('\gamma_{1}=-10 and \gamma_{2}=-10','\gamma_{1}=-5 and \gamma_{2}=-5','\gamma_{1}=-1 and \gamma_{2}=-1','\gamma_{1}=0 and \gamma_{2}=0');hold on;
LEG.FontSize = 10;
ylim([0,1]);
hold on;

% subplot(3,2,5,'Parent',figure1,'FontSize',12);
% plot(Foreign,g_a0','k','LineWidth',1); hold on;
% %plot(Foreign,g_d5','--r','LineWidth',2); hold on;
% %plot(Foreign,g_d1',':m','LineWidth',2); hold on;
% title('\gamma_{1}=0 and \gamma_{2}=0')
% hold on;
% plot([c1 c1],[min([0;0]) max([1;1])],':k','LineWidth',2);
% xlabel('\it fp_{i,t-1}','fontsize',10);
% LEG = legend('\gamma_{1}=0 and \gamma_{2}=0');hold on;
% LEG.FontSize = 10;
% ylim([0,1]);
hold on;

