clear all;
close all;



per = 100;
Foreign(1,1)=0;
for i = 2:per;
Foreign(i,1) =Foreign(i-1,1) +0.01;
end

per3 = 250;
Publicdebt(1,1)=0;
for i = 2:per3;
Publicdebt(i,1) =Publicdebt(i-1,1) +1;
end



[GPSTR, hdr2] = xlsread('ResultGPSTR','sheet1');
[slop_location, hdr2] = xlsread('resultslop_location','sheet1');
[cov, hdr2] = xlsread('resultvcov','sheet1');


c1=slop_location(1,:);
gam1=slop_location(2,:);
gam2=slop_location(3,:);

beta1=GPSTR(1,1);
beta2=GPSTR(2,1);


%Full real
v1=cov(1,1);
v2=cov(2,2);

%Covariance
cv12=cov(1,2);


qsc=Foreign-c1; 
 %%%%GPSTR%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 g=zeros(length(qsc),1);
if gam1<0;
h1=1./gam1.*log(1-gam1.*abs(qsc));
 g1=1./(1+exp(-(h1))) ; 
else
h1=-1./gam1.*(exp(gam1.*abs(qsc))-1);
g1=1./(exp(-(h1))+1);
end
a1=g1(1:sum(qsc<0),:);


if gam2<0;
h2=-1./gam2.*log(1-gam2.*abs(qsc));
 g2=1./(1+exp(-(h2))); 
else 
h2=1./gam2.*(exp(gam2.*abs(qsc))-1);
  g2=1./(exp(-(h2))+1);
end 
b2=g2(sum(qsc<0)+1:end,:);
g= vertcat(a1,b2);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Mean
beta=beta1+beta2*g; 
%Variance for estimation
Var_beta=(v1+2*cv12*g+v2*g.^2);
sd_beta=Var_beta.^(1/2);

beta_up=beta+1.645*sd_beta;
beta_low=beta-1.645*sd_beta;

%Basis point
beta=beta*100;
beta_low=beta_low*100;%
beta_up=beta_up*100;

yconf = [beta_low beta_up];

% For figure(unit %)
Foreign=Foreign*100;
c1=c1*100;


figure1 = figure;
figre1.PaperType       = 'a4';
figure1.PaperUnits      = 'centimeters';
figure1.PaperPosition   = [2,2,12,12];
figure1.Units           = 'centimeters';
figure1.Position        = [2,2,12,12];
figure1.Color           = 'w';
figure1.InvertHardcopy  = 'off';
subplot(1,1,1,'Parent',figure1,'FontSize',12);
shadedplot(Foreign,beta_low',beta_up',[0.9 0.9 1],[0.9 0.9 1]);
hold on;
h(2) =plot(Foreign,beta','-k','LineWidth',0.5); hold on;
hold on;
h(4) =plot([c1 c1], [min([-4;beta_low(:)]) max([beta_low(:);beta_up(:)])],':k','LineWidth',2);
LEG.FontSize = 12;
title('GPSTR','fontsize',15)
% 
xlabel('Share of the foreign private investors(%)','fontsize',15);
ylabel('basis points','fontsize',15);
ylim([-4,12]);
xlim([0,50]);
hold on;



